<?php
/**
 * Created by PhpStorm.
 * User: leo
 * Date: 2018/2/24
 * Time: 下午12:48
 */

namespace frontendApi\modules\v1\controllers;

use Codeception\PHPUnit\ResultPrinter\HTML;
use common\helpers\Cache;
use common\helpers\Date;
use common\helpers\Form;
use common\helpers\LoggerTool;
use common\helpers\Tool;
use common\helpers\user\Info;
use common\models\ApproachDecOrder;
use common\models\ApproachOrder;
use common\models\ApproachOrderGoods;
use common\models\DealType;
use common\models\DecOrder;
use common\models\forms\ApproachOrderForm;
use common\models\forms\DeclarationForm;
use common\models\forms\OrderForm;
use common\models\Order;
use common\models\OrderDec;
use common\models\OrderGoods;
use common\models\OrderGoodsDec;
use common\models\OrderStandard;
use common\models\OrderStandardGoods;
use common\models\ReceiveAddress;
use common\models\Region;
use common\models\ShopGoods;
use common\models\User;
use common\models\UserBonus;
use common\models\UserWallet;
use Yii;
use yii\data\Pagination;
use yii\db\Query;


class ShopController extends BaseController {
    public $modelClass = DecOrder::class;

    /**
     * 商品列表
     * @return mixed
     * @throws \yii\web\HttpException
     */
    public function actionIndex() {
        // 商品分类
        $categoryType = \Yii::$app->request->get('categoryType', 1);

        $condition = ' AND STATUS=1 AND (FIND_IN_SET(2,GIFT_TYPE)>0';
        $isStudio = User::getEnCodeInfo(\Yii::$app->user->id)['IS_STUDIO'];
        if($isStudio==1){
            $condition.= " OR FIND_IN_SET(4,GIFT_TYPE)>0";
        }
        $condition .= ") AND CATEGORY_TYPE = :CATEGORY_TYPE";
        $params[':CATEGORY_TYPE'] = intval($categoryType);

        $data = ShopGoods::lists($condition, $params, [
            'orderBy' => 'SORT ASC,CREATED_AT DESC',
            'from' => ShopGoods::tableName(),
        ]);
        foreach ($data['list'] as $key => $value) {
            if ($value['TYPE'] == 1 || $value['TYPE'] == 2) {
                $data['list'][$key]['DISCOUNT'] = ShopGoods::GOODS_TYPE[$value['TYPE']]['discount'];
            } else {
                $data['list'][$key]['DISCOUNT'] = $value['SELL_DISCOUNT']*100;
            }
            // $data['list'][$key]['DISCOUNT'] = ShopGoods::GOODS_TYPE[$value['TYPE']]['discount'];
        }
        return static::notice($data);
    }

    /**
     * 获取商品详情
     * @return mixed
     * @throws \yii\web\HttpException
     */
    public function actionGoodsDetail(){
        $id = \Yii::$app->request->get('id');
        $data = null;
        if($id){
            $data = ShopGoods::findOneAsArray('ID=:ID AND STATUS=1', [':ID'=>$id]);
        }
        return static::notice($data);
    }

    /**
     * 购物车订单展示
     * @throws \yii\web\HttpException
     */
    public function actionShowCart(){
        $userId = \Yii::$app->user->id;
        $payList = ShopGoods::payTypes();
        $allAddress = ReceiveAddress::findAllAsArray('USER_ID=:USER_ID', [':USER_ID'=>$userId]);
        if($allAddress) {
            foreach ($allAddress as $key => $row) {
                $allAddress[$key]['PROVINCE_NAME'] = Region::getCnName($row['PROVINCE']);
                $allAddress[$key]['CITY_NAME'] = Region::getCnName($row['CITY']);
                $allAddress[$key]['COUNTY_NAME'] = Region::getCnName($row['COUNTY']);
            }
        }
        $userBalance = [
//            'points' => 0,
            'cash' => 0,
//            'exchange' => 0,
            'tourism_points' => 0,
            'garage_points' => 0,
        ];
        if ($userBonusResult = UserBonus::findOneAsArray(['USER_ID' => $userId])) {
//            $userBalance['points'] = $userBonusResult['RECONSUME_POINTS'];
//            $userBalance['exchange'] = $userBonusResult['EXCHANGE_POINTS'];
            $userBalance['tourism_points'] = $userBonusResult['TOURISM_POINTS'];
            $userBalance['garage_points'] = $userBonusResult['GARAGE_POINTS'];
        }
        if ($userCashResult = UserWallet::findOneAsArray(['USER_ID' => $userId])) {
            $userBalance['cash'] = $userCashResult['CASH'];
        }

        // 汇率
        $exchangeRate = floatval(Cache::getSystemConfig()['exchangeRate']['VALUE'] ?? 0);
        // 运费.奈拉
        $freight = floatval(Cache::getSystemConfig()['freight']['VALUE'] ?? 0);
        // 普通商品免运费阈值.奈拉
        $freeShipping = floatval(Cache::getSystemConfig()['freeShipping']['VALUE'] ?? 0);

        return static::notice(
            [
                'payList'=>$payList,
                'allAddress'=>$allAddress,
                'userBalance'=>$userBalance,
                'sellType' => ShopGoods::CATEGORY_TYPE,
                'freight' => $freight,
                'freeShipping' => $freeShipping,
            ]);
    }

    /**
     * 确认订单
     */
    public function actionSureOrder(){
        if (\Yii::$app->request->isPost) {
            $formModel = new OrderForm();
            $formModel->scenario = 'userOrder';
            $formModel->remark = '复销备注';
            $post = \Yii::$app->request->post();
            $post['type'] = DeclarationForm::TYPE_FX;
            if ($formModel->load($post, '') && $order = $formModel->add()) {
                return static::notice($order);
            } else {
                return static::notice(Form::formatErrorsForApi($formModel->getErrors()),400);
            }
        }
    }

    /**
     * 订单支付成功
     * @throws \yii\web\HttpException
     */
    public function actionPaySuccess(){
        $orderSn = \Yii::$app->request->get('orderSn');
        $data = null;
        if($orderSn){
            $data = Order::findOneAsArray('SN=:SN', [':SN'=>$orderSn]);
        }
        return static::notice($data);
    }

    /**
     * 确认订单
     */
    public function actionSureApproachOrder(){
        if (\Yii::$app->request->isPost) {
            $formModel = new ApproachOrderForm();
            $formModel->scenario = 'userOrder';
            $formModel->remark = '复销备注';
            $post = \Yii::$app->request->post();
            $post['type'] = DeclarationForm::TYPE_FX;
            if ($formModel->load($post, '') && $order = $formModel->add()) {
                return static::notice($order);
            } else {
                return static::notice(Form::formatErrorsForApi($formModel->getErrors()),400);
            }
        }
    }

    /**
     * PayStack支付成功的webhook.
     * @throws \yii\web\HttpException
     */
    public function actionVerifyApproachOrder() {
        if (\Yii::$app->request->isPost) {
            $request = \Yii::$app->request->post();
            // TODO：支付webhook回调日志
            LoggerTool::info($request);
            $data = $request['data'];
            $status = $request['data']['status'] ?? 'false';
            // 订单状态
            $orderStatus = ($status == 'success') ? \Yii::$app->params['orderStatus']['paid']['value'] : \Yii::$app->params['orderStatus']['failPaid']['value'];

            $customFields = $data['metadata']['custom_fields'][0] ?? [];
            $oderSn = $customFields['value'] ?? '';

            $formModel = new ApproachOrderForm();
            $formModel->scenario = 'verifyPayStack';
            $load = [
                'sn' => $oderSn,
                'scenario' => 'verifyPayStack',
                'status' => $orderStatus,
                'note' => [
                    'id' => $data['id'],
                    'domain' => $data['domain'],
                    'status' => $data['status'],
                    'reference' => $data['reference'],
                    'amount' => $data['amount'],
                    'created_at' => $data['created_at'],
                    'paid_at' => $data['paid_at'],
                    'channel' => $data['channel'],
                    'currency' => $data['currency'],
                    'ip_address' => $data['ip_address'],
                    'metadata' => $data['metadata'],
                    'customer' => $data['customer'],
                    'email' => $data['customer']['email'] ?? '',
                ],
            ];

            if ($formModel->load($load, '') && $order = $formModel->verifyPayStack()) {
                LoggerTool::error($order);
                return http_response_code(200);
            } else {
                LoggerTool::error(Form::formatErrorsForApi($formModel->getErrors()));
                return http_response_code(500);
            }
        }

        return http_response_code(200);
    }

    /**
     * 删除准订单
     */
    public function actionDeleteApproachOrder()
    {
        $orderSn = \Yii::$app->request->post('orderSn');
        // 删除订单中间表
        ApproachOrder::deleteAll('SN = :SN', [':SN' => $orderSn]);
        // 删除订单商品中间表
        ApproachOrderGoods::deleteAll('ORDER_SN = :ORDER_SN', [':ORDER_SN' => $orderSn]);
        // 删除报单中间表
        ApproachDecOrder::deleteAll('ORDER_SN = :ORDER_SN', [':ORDER_SN' => $orderSn]);

        return static::notice('');
    }

    /**
     * 我的报单
     * @return mixed
     * @throws \yii\web\HttpException
     */
    public function actionDecOrderList() {
        $condition = ' DO.USER_ID=:USER_ID AND DO.IS_DEL=0';
        $params[':USER_ID'] = \Yii::$app->user->id;

        $orderQuery = DecOrder::find()
            ->alias('DO')
            ->where($condition, $params)
            ->select('DO.*,O.STATUS,U.USER_NAME USER_NAME,U.REAL_NAME REAL_NAME,RU.USER_NAME REC_USER_NAME,RU.REAL_NAME REC_REAL_NAME,CU.USER_NAME CON_USER_NAME,CU.REAL_NAME CON_REAL_NAME,OG.SKU_CODE,OG.GOODS_TITLE,OG.BUY_NUMS,OG.REAL_PRICE,OG.REAL_PV,OG.TAX_RATE')
            ->join('LEFT JOIN', User::tableName() . ' AS U', 'DO.TO_USER_ID=U.ID')
            ->join('LEFT JOIN', User::tableName() . ' AS RU', 'DO.REC_USER_ID=RU.ID')
            ->join('LEFT JOIN', User::tableName() . ' AS CU', 'DO.CON_USER_ID=CU.ID')
            ->join('LEFT JOIN', OrderGoods::tableName() . ' AS OG', 'OG.ORDER_SN=DO.ORDER_SN')
            ->join('LEFT JOIN', Order::tableName() . ' AS O', 'O.SN=DO.ORDER_SN')
            ->orderBy('DO.CREATED_AT DESC');

        // 订单中间表只查询待支付和支付失败的订单
        $params[':NOT_PAID'] = \Yii::$app->params['orderStatus']['notPaid']['value'];   // 待支付
        $params[':FAIL_PAID'] = \Yii::$app->params['orderStatus']['failPaid']['value'];   // 支付失败
        $orderStandardQuery = ApproachDecOrder::find()
            ->alias('DO')
            ->where($condition . ' AND (O.STATUS = :NOT_PAID OR O.STATUS = :FAIL_PAID)', $params)
            ->select('DO.*,O.STATUS,U.USER_NAME USER_NAME,U.REAL_NAME REAL_NAME,RU.USER_NAME REC_USER_NAME,RU.REAL_NAME REC_REAL_NAME,CU.USER_NAME CON_USER_NAME,CU.REAL_NAME CON_REAL_NAME,OG.SKU_CODE,OG.GOODS_TITLE,OG.BUY_NUMS,OG.REAL_PRICE,OG.REAL_PV,OG.TAX_RATE')
            ->join('LEFT JOIN', User::tableName() . ' AS U', 'DO.TO_USER_ID=U.ID')
            ->join('LEFT JOIN', User::tableName() . ' AS RU', 'DO.REC_USER_ID=RU.ID')
            ->join('LEFT JOIN', User::tableName() . ' AS CU', 'DO.CON_USER_ID=CU.ID')
            ->join('LEFT JOIN', ApproachOrderGoods::tableName() . ' AS OG', 'OG.ORDER_SN=DO.ORDER_SN')
            ->join('LEFT JOIN', ApproachOrder::tableName() . ' AS O', 'O.SN=DO.ORDER_SN')
            ->orderBy('DO.CREATED_AT DESC');

        $queryAll = $orderQuery->union($orderStandardQuery, true);
        $query = (new Query())->from(['Q' => $queryAll])->select('Q.*')->distinct()->orderBy(['CREATED_AT' => SORT_DESC]);

        $totalCount = $query->count();
        $pagination = new Pagination(['totalCount' => $totalCount, 'pageSize' => \Yii::$app->request->get('pageSize')]);
        $lists = $query->offset($pagination->offset)->limit($pagination->limit)->all();

        $data = [
            'list' => $lists,
            'currentPage'=>$pagination->page,
            'totalPages'=>$pagination->pageCount,
            'startNum' => $pagination->page * $pagination->pageSize + 1,
            'totalCount' => $pagination->totalCount,
            'pageSize' => $pagination->pageSize,
        ];

        foreach ($data['list'] as &$value) {
            $value['TAX_AMOUNT'] = Tool::calculateTax($value['REAL_PRICE'], floatval($value['TAX_RATE']), intval($value['BUY_NUMS']));
            $value['STATUS'] = \Yii::$app->params['orderStatus'][$value['STATUS']]['label'] ?? '';
        }

        return static::notice($data);
    }

    /**
     * 我的订单
     * @return mixed
     * @throws \yii\web\HttpException
     */
    public function actionOrderList() {
        $uname = Info::getUserNameByUserId(\Yii::$app->user->id);
        $condition = " (USER_ID=:USER_ID OR CREATE_USER='$uname')";
        $params[':USER_ID'] = \Yii::$app->user->id;
        $orderQuery = Order::find()
            ->alias('O')
            ->where($condition, $params)
            ->select('O.*,U.REAL_NAME,SG.CATEGORY_TYPE,OG.REAL_PRICE,OG.TAX_RATE,OG.BUY_NUMS,OG.SKU_CODE,OG.GOODS_TITLE,OG.REAL_PV')
            ->join('LEFT JOIN', User::tableName() . ' AS U', 'U.ID=O.USER_ID')
            ->join('LEFT JOIN', OrderGoods::tableName() . ' AS OG', 'OG.ORDER_SN=O.SN')
            ->join('LEFT JOIN', ShopGoods::tableName() . ' AS SG', 'SG.ID=OG.GOODS_ID')
            ->orderBy('O.CREATED_AT DESC');

        // 订单中间表只查询待支付和支付失败的订单
        $params[':NOT_PAID'] = \Yii::$app->params['orderStatus']['notPaid']['value'];   // 待支付
        $params[':FAIL_PAID'] = \Yii::$app->params['orderStatus']['failPaid']['value'];   // 支付失败
        $orderStandardQuery = ApproachOrder::find()
            ->alias('O')
            ->where($condition . ' AND (O.STATUS = :NOT_PAID OR O.STATUS = :FAIL_PAID)', $params)
            ->select('O.*,U.REAL_NAME,SG.CATEGORY_TYPE,OG.REAL_PRICE,OG.TAX_RATE,OG.BUY_NUMS,OG.SKU_CODE,OG.GOODS_TITLE,OG.REAL_PV')
            ->join('LEFT JOIN', User::tableName() . ' AS U', 'U.ID=O.USER_ID')
            ->join('LEFT JOIN', ApproachOrderGoods::tableName() . ' AS OG', 'OG.ORDER_SN=O.SN')
            ->join('LEFT JOIN', ShopGoods::tableName() . ' AS SG', 'SG.ID=OG.GOODS_ID')
            ->orderBy('O.CREATED_AT DESC');

        $queryAll = $orderQuery->union($orderStandardQuery, true);
        $query = (new Query())->from(['Q' => $queryAll])->select('Q.*')->distinct()->orderBy(['CREATED_AT' => SORT_DESC]);

        $totalCount = $query->count();
        $pagination = new Pagination(['totalCount' => $totalCount, 'pageSize' => \Yii::$app->request->get('pageSize')]);
        $lists = $query->offset($pagination->offset)->limit($pagination->limit)->all();

        $data = [
            'list' => $lists,
            'currentPage'=>$pagination->page,
            'totalPages'=>$pagination->pageCount,
            'startNum' => $pagination->page * $pagination->pageSize + 1,
            'totalCount' => $pagination->totalCount,
            'pageSize' => $pagination->pageSize,
        ];

        foreach ($data['list'] as $key => $value) {
            $data['list'][$key]['PAY_AT'] = $value['PAY_AT'] ? Date::convert($value['PAY_AT'],'Y-m-d H:i:s') : '';
            $data['list'][$key]['CREATED_AT'] = $value['CREATED_AT'] ? Date::convert($value['CREATED_AT'],'Y-m-d H:i:s') : '';
            $data['list'][$key]['CATEGORY_TYPE'] = intval($value['CATEGORY_TYPE']);
            $data['list'][$key]['PAY_TYPE'] = array_column(ShopGoods::SALE_TYPE, NULL, 'label')[$value['PAY_TYPE']]['name'] ?? '';
            $data['list'][$key]['STATUS'] = \Yii::$app->params['orderStatus'][$value['STATUS']]['label'] ?? '';
            $data['list'][$key]['CATEGORY'] = array_column(ShopGoods::CATEGORY_TYPE, NULL, 'id')[$value['CATEGORY_TYPE']]['name'] ?? ShopGoods::CATEGORY_TYPE[0]['name'];
            $data['list'][$key]['FULL_ADDRESS'] = $value['ADDRESS'];//.', '.$value['CITY_NAME'].', '.$value['LGA_NAME'];
            if($value['CITY_NAME']){
                $data['list'][$key]['FULL_ADDRESS'] .= ', ' . $value['CITY_NAME'];
            }
            if($value['LGA_NAME']){
                $data['list'][$key]['FULL_ADDRESS'] .= ', ' . $value['LGA_NAME'];
            }
            if($value['PROVINCE']){
                $data['list'][$key]['FULL_ADDRESS'] .= ', ' . Region::getCnName($value['PROVINCE']);
            }
//            if($value['CITY']){
//                $data['list'][$key]['FULL_ADDRESS'] .= Region::getCnName($value['CITY']);
//            }
//            if($value['COUNTY']){
//                $data['list'][$key]['FULL_ADDRESS'] .= Region::getCnName($value['COUNTY']);
//            }
            $data['list'][$key]['TAX_AMOUNT'] = Tool::formatPrice(($value['REAL_PRICE'] - $value['REAL_PRICE'] / (1 + $value['TAX_RATE'] / 100)) * $value['BUY_NUMS']);
        }

        return static::notice($data);
    }

    /**
     * 会员复消
     */
    public function actionReconsume() {
        $condition = ' AND STATUS=1 AND (FIND_IN_SET(2,GIFT_TYPE)>0 OR FIND_IN_SET(4,GIFT_TYPE)>0)';
        $data = ShopGoods::lists($condition, [], [
            'orderBy' => 'SORT ASC,CREATED_AT DESC',
            'from' => ShopGoods::tableName(),
        ]);
        foreach ($data['list'] as $key => $value) {
            if ($value['TYPE'] == 1 || $value['TYPE'] == 2) {
                $data['list'][$key]['DISCOUNT'] = ShopGoods::GOODS_TYPE[$value['TYPE']]['discount'];
            } else {
                $data['list'][$key]['DISCOUNT'] = $value['SELL_DISCOUNT']*100;
            }
            //$data['list'][$key]['DISCOUNT'] = ShopGoods::GOODS_TYPE[$value['TYPE']]['discount'];
        }
        return static::notice($data);
    }

    /**
     * 帮会员复消购物车
     * @throws \yii\web\HttpException
     */
    public function actionReconsumeCart(){
        $userId = \Yii::$app->user->id;
        $payList = ['cash'=>['name'=>'Account Balance'],];//余额支付
        $userBalance = [
            'points' => 0,
            'cash' => 0
        ];
        if ($userBonusResult = UserBonus::findOneAsArray(['USER_ID' => $userId])) {
            $userBalance['points'] = $userBonusResult['RECONSUME_POINTS'];
        }
        if ($userCashResult = UserWallet::findOneAsArray(['USER_ID' => $userId])) {
            $userBalance['cash'] = $userCashResult['CASH'];
        }
        return static::notice(['payList'=>$payList,'userBalance'=>$userBalance]);
    }

    /**
     * 帮会员复消确认订单
     */
    public function actionReconsumeSureOrder(){
        if (\Yii::$app->request->isPost) {
            $formModel = new OrderForm();
            $formModel->scenario = 'reconsumeOrder';
            $formModel->remark = '帮会员复销';
            $post = \Yii::$app->request->post();
            $post['type'] = DeclarationForm::TYPE_FX;
            if ($formModel->load($post, '') && $formModel->reconsumeAdd()) {
                return static::notice('帮会员复消成功');
            } else {
                return static::notice(Form::formatErrorsForApi($formModel->getErrors()),400);
            }
        }
    }

    /**
     * 商品列表tabs分类
     * @return mixed
     * @throws \yii\web\HttpException
     */
    public function actionGoodsActive()
    {
        $data = [
//            [
//                'name' => 'bonus',
//                'label' => '奖金商品',
//            ],
            [
                'name' => '1',
                'label' => 'Standard Products',//普通商品列表
            ],
//            [
//                'name' => '4',
//                'label' => 'Travel Fund Products',//旅游积分商品
//            ],
            [
                'name' => '5',
                'label' => 'Car/Villa Fund Products',//车房积分商品
            ],
        ];
        return static::notice($data);
    }

    /**
     * 导出订单.
     * @return mixed
     * @throws \yii\web\HttpException
     * @throws \Mpdf\MpdfException
     */
    public function actionOrderExport()
    {
        $uname = Info::getUserNameByUserId(\Yii::$app->user->id);
        $orderSn = \Yii::$app->request->get('orderSn');

        $condition = " AND ORDER_TYPE='FX' AND (USER_ID=:USER_ID OR CREATE_USER='$uname') AND SN=:SN";
        $params = [
            ':USER_ID' => \Yii::$app->user->id,
            ':SN' => $orderSn,
        ];

        $orderQuery = Order::find()
            ->alias('O')
            ->where($condition, $params)
            ->select('O.*,U.REAL_NAME,SG.CATEGORY_TYPE,OG.REAL_PRICE,OG.TAX_RATE,OG.BUY_NUMS,OG.SKU_CODE,OG.GOODS_TITLE,OG.REAL_PV')
            ->join('LEFT JOIN', User::tableName() . ' AS U', 'U.ID=O.USER_ID')
            ->join('LEFT JOIN', OrderGoods::tableName() . ' AS OG', 'OG.ORDER_SN=O.SN')
            ->join('LEFT JOIN', ShopGoods::tableName() . ' AS SG', 'SG.ID=OG.GOODS_ID')
            ->orderBy('O.CREATED_AT DESC');

        // 订单中间表只查询待支付和支付失败的订单
        $params[':NOT_PAID'] = \Yii::$app->params['orderStatus']['notPaid']['value'];   // 待支付
        $params[':FAIL_PAID'] = \Yii::$app->params['orderStatus']['failPaid']['value'];   // 支付失败
        $orderStandardQuery = ApproachOrder::find()
            ->alias('O')
            ->where($condition . ' AND (O.STATUS = :NOT_PAID OR O.STATUS = :FAIL_PAID)', $params)
            ->select('O.*,U.REAL_NAME,SG.CATEGORY_TYPE,OG.REAL_PRICE,OG.TAX_RATE,OG.BUY_NUMS,OG.SKU_CODE,OG.GOODS_TITLE,OG.REAL_PV')
            ->join('LEFT JOIN', User::tableName() . ' AS U', 'U.ID=O.USER_ID')
            ->join('LEFT JOIN', ApproachOrderGoods::tableName() . ' AS OG', 'OG.ORDER_SN=O.SN')
            ->join('LEFT JOIN', ShopGoods::tableName() . ' AS SG', 'SG.ID=OG.GOODS_ID')
            ->orderBy('O.CREATED_AT DESC');

        $queryAll = $orderQuery->union($orderStandardQuery, true);
        $query = (new Query())->from(['Q' => $queryAll])->select('Q.*')->distinct()->orderBy(['CREATED_AT' => SORT_DESC]);

        $totalCount = $query->count();
        $pagination = new Pagination(['totalCount' => $totalCount, 'pageSize' => \Yii::$app->request->get('pageSize')]);
        $lists = $query->offset($pagination->offset)->limit($pagination->limit)->all();

        $data = [
            'list' => $lists,
            'currentPage'=>$pagination->page,
            'totalPages'=>$pagination->pageCount,
            'startNum' => $pagination->page * $pagination->pageSize + 1,
            'totalCount' => $pagination->totalCount,
            'pageSize' => $pagination->pageSize,
        ];

        $userId = '';
        $userName = '';
        $address = '';
        $mobile = '';
        $orderAt = '';
        $orderDetails = '';
        $orderAmount = 0;  // 合计总额
        $orderNums = 0; // 合计总数
        $totalTaxAmount = 0; // 合计税额
        $totalAmount = 0;
        foreach ($data['list'] as $key => $value) {
            $provinceName = $value['PROVINCE'] ? Region::getCnName($value['PROVINCE']) : '';
            $cityName = $value['CITY'] ? Region::getCnName($value['CITY']) : '';
            $countyName = $value['COUNTY'] ? Region::getCnName($value['COUNTY']) : '';

            $userId = $value['USER_NAME'];
            $userName = $value['REAL_NAME'];
            $address = $provinceName . $cityName . $countyName . $value['ADDRESS'];
            $mobile = $value['MOBILE'];
            $orderAt = Date::convert($value['PAY_AT'],'Y-m-d H:i:s');

            // 总价
            $totalAmount = $value['BUY_NUMS'] * $value['REAL_PRICE'];
            $orderAmount += $totalAmount;
            $orderNums += $value['BUY_NUMS'];
            // 税额
            $taxAmount = floatval(Tool::formatPrice(($value['REAL_PRICE'] - ($value['REAL_PRICE'] / (1 + $value['TAX_RATE'] / 100))) * $value['BUY_NUMS']));
            $totalTaxAmount += $taxAmount;
            $productAmount = Tool::formatAmount($value['REAL_PRICE']);
            $taxAmount = Tool::formatAmount($taxAmount);
            $totalAmount = Tool::formatAmount($totalAmount);
            // 订单详情
            $orderDetails .= <<<EOT
                <tr>
                    <td>{$value['SKU_CODE']}</td>
                    <td>{$value['GOODS_TITLE']}</td>
                    <td style="text-align: right;">{$productAmount}</td>
                    <td>{$value['BUY_NUMS']}</td>
                    <td style="text-align: right;">{$value['TAX_RATE']}</td>
                    <td style="text-align: right;">{$taxAmount}</td>
                    <td style="text-align: right;">{$totalAmount}</td> 
                </tr>
EOT;
        }

        // 订单基本信息
        $orderBase = <<<ORDER
            <table border="1" style="table-layout: fixed; padding: 10px 20px;" width="100%">
                <tr>
                    <td width="30%" style="font-weight: bold; text-align: center; font-size: 14px;">Member code</td>
                    <td width="70%">{$userId}</td>
                </tr>
                <tr>
                    <td width="30%" style="font-weight: bold; text-align: center; font-size: 14px;">Member name</td>
                    <td width="70%">{$userName}</td>
                </tr>
                <tr>
                    <td width="30%" style="font-weight: bold; text-align: center; font-size: 14px;">Member address</td>
                    <td width="70%">{$address}</td>
                </tr>
                <tr>
                    <td width="30%" style="font-weight: bold; text-align: center; font-size: 14px;">Member phone</td>
                    <td width="70%">{$mobile}</td>
                </tr>
                <tr>
                    <td width="30%" style="font-weight: bold; text-align: center; font-size: 14px;">Order code</td>
                    <td width="70%">{$orderSn}</td>
                </tr>
                <tr>
                    <td width="30%" style="font-weight: bold; text-align: center; font-size: 14px;">Creation time</td>
                    <td width="70%">{$orderAt}</td>
                </tr>
                <tr>
                    <td class="bg" style="font-weight: bold; font-size: 14px; text-align: center;">Order detail</td>
                    <td class="bg"></td>
                </tr>
            </table>
ORDER;

        $l['a_meta_charset'] = 'UTF-8';
        $l['a_meta_dir'] = 'ltr';
        $l['a_meta_language'] = 'zh';
        $l['w_page'] = '页面';

        $orderAmount = Tool::formatAmount($orderAmount);
        $totalTaxAmount = Tool::formatAmount($totalTaxAmount);

        $context = <<<ORDER
            <!doctype html>
            <html lang="en">
            <head>
                <meta charset="UTF-8" />
                <title>Order detail</title>
                <style>
                    table {
                        border-collapse: collapse;
                    }
                    table td, table th {
                        border: 1px solid #ccc;
                        padding: 5px 5px;
                        border-collapse: collapse;
                    }
                    /*td {*/
                    /*    padding: 120px;*/
                    /*}*/
                    .bg {
                        background-color: #ccc;
                    }
                </style>
            </head>
            <body>
                <div class="content">
                    <p style="text-align: center; font-weight: bold; font-size: 22px;"><b>Order detail</b><br></p>
                    <div>
                        <div style="display: block; width: 100%;">
                            {$orderBase}
                            
                            <table border="1" width="100%" style="padding: 10px 5px; text-align: center;">
                                <tr>
                                    <th width="15%" style="font-size: 14px; font-weight: bold; text-align: center;">Product code</th>
                                    <th width="25%" style="font-size: 14px; font-weight: bold; text-align: center;">Product name</th>
                                    <th width="15%" style="font-size: 14px; font-weight: bold; text-align: center;">Product price</th>
                                    <th width="10%" style="font-size: 14px; font-weight: bold; text-align: center;">Quantity</th>
                                    <th width="10%" style="font-size: 14px; font-weight: bold; text-align: center;">Tax rate</th>
                                    <th width="10%" style="font-size: 14px; font-weight: bold; text-align: center;">Tax</th>
                                    <th width="15%" style="font-size: 14px; font-weight: bold; text-align: center;">Total amount</th>
                                </tr>
                                {$orderDetails}
                                <tr>
                                    <td colspan="3">Total</td>
                                    <td>{$orderNums}</td>
                                    <td></td>
                                    <td style="text-align: right;">{$totalTaxAmount}</td>
                                    <td style="text-align: right;">{$orderAmount}</td>
                                </tr>
                            </table>
                        </div>
                        
                        <div style="width: 100%; margin-top: 50px; height: 30px;">
                            <table width="100%" style="border: none; padding: 10px 20px; text-align: center;">
                                <tr style="border: none;">
                                    <td width="70%" style="border: none;"></td>
                                    <td width="30%" style="font-weight: bold; text-align: left; font-size: 14px; border: none;">Signature：</td>
                                </tr>
                                <tr style="border: none;">
                                    <td width="70%" style="border: none;"></td>
                                    <td width="30%" style="font-weight: bold; text-align: left; font-size: 14px; border: none;">Date：</td>
                                </tr>
                            </table>
                        </div>
                    </div>
                </div>
            </body>
            </html>
ORDER;
        require_once (\Yii::$app->vendorPath . '/tecnickcom/tcpdf/tcpdf.php');

        $pdf = new \TCPDF(PDF_PAGE_ORIENTATION, PDF_UNIT, PDF_PAGE_FORMAT, true, 'UTF-8', false);
        // 设置打印模式
        $pdf->SetCreator(PDF_CREATOR);
        $pdf->SetAuthor('DaZe');
        $pdf->SetTitle($orderSn);
        $pdf->SetSubject('TCPDF Tutorial');
        $pdf->SetKeywords('TCPDF, PDF, example, test, guide');
        // 是否显示页眉
        $pdf->setPrintHeader(false);
        // 设置页眉字体
        $pdf->setHeaderFont(Array('dejavusans', '', '12'));
        // 页眉距离顶部的距离
        $pdf->SetHeaderMargin('5');
        // 是否显示页脚
        $pdf->setPrintFooter(false);
        // 设置默认等宽字体
        $pdf->SetDefaultMonospacedFont(PDF_FONT_MONOSPACED);
        // 设置行高
        $pdf->setCellHeightRatio(1);
        // 设置左、上、右的间距
        $pdf->SetMargins('10', '10', '10');
        // 设置是否自动分页  距离底部多少距离时分页
        $pdf->SetAutoPageBreak(TRUE, '15');
        // 设置图像比例因子
        $pdf->setImageScale(PDF_IMAGE_SCALE_RATIO);
        if (@file_exists(\Yii::$app->vendorPath . 'tecnickcom/tcpdf/examples/lang/eng.php')) {
            require_once(\Yii::$app->vendorPath . '/tecnickcom/tcpdf/examples/lang/eng.php');
            $pdf->setLanguageArray($l);
        }
        $pdf->setFontSubsetting(true);
        $pdf->AddPage();
        // 设置字体
        $pdf->SetFont('stsongstdlight', '', 10, '', true);
        $pdf->writeHTML($context);

        ob_clean();

        $file_name = $orderSn . '.pdf';
        $path = 'pdfs/' . $file_name;
        $pdf->Output(Yii::$app->basePath . '/web/' . $path, 'F');

        @exec('chmod -R 777 /' . Yii::$app->basePath . '/web' . $path);

        return static::notice(['fileUrl' => $path, 'targetName' => $file_name]);
    }

    /**
     * 导出订单.
     * @return mixed
     * @throws \yii\web\HttpException
     */
    public function actionDecOrderExport()
    {
        $orderSn = \Yii::$app->request->get('orderSn');

        $condition = ' AND DO.USER_ID=:USER_ID AND IS_DEL=0 AND DO.ORDER_SN=:ORDER_SN';
        $params = [
            ':USER_ID'  => \Yii::$app->user->id,
            ':ORDER_SN' => $orderSn,
        ];
        $data = DecOrder::lists($condition, $params, [
            'select' => 'DO.*,U.USER_NAME USER_NAME,U.REAL_NAME REAL_NAME,RU.USER_NAME REC_USER_NAME,RU.REAL_NAME REC_REAL_NAME,CU.USER_NAME CON_USER_NAME,CU.REAL_NAME CON_REAL_NAME,OG.*,OD.PROVINCE,OD.CITY,OD.COUNTY,OD.ADDRESS,OD.MOBILE,OD.PAY_AT,OD.ORDER_AMOUNT',
            'orderBy' => 'DO.CREATED_AT DESC',
            'from' => DecOrder::tableName() . ' AS DO',
            'join' => [
                ['LEFT JOIN', User::tableName() . ' AS U', 'DO.TO_USER_ID=U.ID'],
                ['LEFT JOIN', User::tableName() . ' AS RU', 'DO.REC_USER_ID=RU.ID'],
                ['LEFT JOIN', User::tableName() . ' AS CU', 'DO.CON_USER_ID=CU.ID'],
                ['LEFT JOIN', OrderGoods::tableName() . ' AS OG', 'OG.ORDER_SN=DO.ORDER_SN'],
                ['LEFT JOIN', Order::tableName() . ' AS OD', 'OD.SN=DO.ORDER_SN'],
            ],
        ]);

        $userId = '';
        $userName = '';
        $address = '';
        $mobile = '';
        $orderAt = '';
        $orderDetails = '';
        $orderAmount = 0;  // 合计总额
        $orderNums = 0; // 合计总数
        $totalTaxAmount = 0; // 合计税额
        $totalAmount = 0;
        foreach ($data['list'] as $key => $value) {
            $provinceName = $value['PROVINCE'] ? Region::getCnName($value['PROVINCE']) : '';
            $cityName = $value['CITY'] ? Region::getCnName($value['CITY']) : '';
            $countyName = $value['COUNTY'] ? Region::getCnName($value['COUNTY']) : '';

            $userId = $value['USER_NAME'];
            $userName = $value['REAL_NAME'];
            $address = $provinceName . $cityName . $countyName . $value['ADDRESS'];
            $mobile = $value['MOBILE'];
            $orderAt = Date::convert($value['PAY_AT'] ?? $value['CREATED_AT'],'Y-m-d H:i:s');

            // 总价
            $totalAmount = $value['BUY_NUMS'] * $value['REAL_PRICE'];
            $orderAmount += $totalAmount;
            $orderNums += $value['BUY_NUMS'];
            // 税额
            $taxAmount = floatval(Tool::formatPrice(($value['REAL_PRICE'] - ($value['REAL_PRICE'] / (1 + $value['TAX_RATE'] / 100))) * $value['BUY_NUMS']));
            $totalTaxAmount += $taxAmount;
            $taxAmount = sprintf('%.2f', $taxAmount);
            $totalAmount = sprintf('%.2f', $totalAmount);
            // 订单详情
            $orderDetails .= <<<EOT
                <tr>
                    <td>{$value['SKU_CODE']}</td>
                    <td>{$value['GOODS_TITLE']}</td>
                    <td style="text-align: right;">{$value['REAL_PRICE']}</td>
                    <td>{$value['BUY_NUMS']}</td>
                    <td style="text-align: right;">{$value['TAX_RATE']}</td>
                    <td style="text-align: right;">{$taxAmount}</td>
                    <td style="text-align: right;">{$totalAmount}</td> 
                </tr>
EOT;
        }

        // 订单基本信息
        $orderBase = <<<ORDER
            <table border="1" style="table-layout: fixed; padding: 10px 20px;" width="100%">
                <tr>
                    <td width="30%" style="font-weight: bold; text-align: center; font-size: 14px;">Member code</td>
                    <td width="70%">{$userId}</td>
                </tr>
                <tr>
                    <td width="30%" style="font-weight: bold; text-align: center; font-size: 14px;">Member name</td>
                    <td width="70%">{$userName}</td>
                </tr>
                <tr>
                    <td width="30%" style="font-weight: bold; text-align: center; font-size: 14px;">Member address</td>
                    <td width="70%">{$address}</td>
                </tr>
                <tr>
                    <td width="30%" style="font-weight: bold; text-align: center; font-size: 14px;">Member phone</td>
                    <td width="70%">{$mobile}</td>
                </tr>
                <tr>
                    <td width="30%" style="font-weight: bold; text-align: center; font-size: 14px;">Order code</td>
                    <td width="70%">{$orderSn}</td>
                </tr>
                <tr>
                    <td width="30%" style="font-weight: bold; text-align: center; font-size: 14px;">Creation time</td>
                    <td width="70%">{$orderAt}</td>
                </tr>
                <tr>
                    <td class="bg" style="font-weight: bold; font-size: 14px; text-align: center;">Order detail</td>
                    <td class="bg"></td>
                </tr>
            </table>
ORDER;

        $l['a_meta_charset'] = 'UTF-8';
        $l['a_meta_dir'] = 'ltr';
        $l['a_meta_language'] = 'zh';
        $l['w_page'] = '页面';

        $orderAmount = sprintf('%.2f', $orderAmount);
        $totalTaxAmount = sprintf('%.2f', $totalTaxAmount);

        $context = <<<ORDER
            <!doctype html>
            <html lang="en">
            <head>
                <meta charset="UTF-8" />
                <title>Order detail</title>
                <style>
                    table {
                        border-collapse: collapse;
                    }
                    table td, table th {
                        border: 1px solid #ccc;
                        padding: 5px 5px;
                        border-collapse: collapse;
                    }
                    /*td {*/
                    /*    padding: 120px;*/
                    /*}*/
                    .bg {
                        background-color: #ccc;
                    }
                </style>
            </head>
            <body>
                <div class="content">
                    <p style="text-align: center; font-weight: bold; font-size: 22px;"><b>Order detail</b><br></p>
                    <div>
                        <div style="display: block; width: 100%;">
                            {$orderBase}
                            
                            <table border="1" width="100%" style="padding: 10px 20px; text-align: center;">
                                <tr>
                                    <th width="15%" style="font-size: 14px; font-weight: bold; text-align: center;">Product code</th>
                                    <th width="25%" style="font-size: 14px; font-weight: bold; text-align: center;">Product name</th>
                                    <th width="15%" style="font-size: 14px; font-weight: bold; text-align: center;">Product price</th>
                                    <th width="10%" style="font-size: 14px; font-weight: bold; text-align: center;">Quantity</th>
                                    <th width="10%" style="font-size: 14px; font-weight: bold; text-align: center;">Tax rate</th>
                                    <th width="10%" style="font-size: 14px; font-weight: bold; text-align: center;">Tax</th>
                                    <th width="15%" style="font-size: 14px; font-weight: bold; text-align: center;">Total amount</th>
                                </tr>
                                {$orderDetails}
                                <tr>
                                    <td colspan="3">Total</td>
                                    <td>{$orderNums}</td>
                                    <td></td>
                                    <td>{$totalTaxAmount}</td>
                                    <td>{$orderAmount}</td>
                                </tr>
                            </table>
                        </div>
                        
                        <div style="width: 100%; margin-top: 50px; height: 30px;">
                            <table width="100%" style="border: none; padding: 10px 20px; text-align: center;">
                                <tr style="border: none;">
                                    <td width="70%" style="border: none;"></td>
                                    <td width="30%" style="font-weight: bold; text-align: left; font-size: 14px; border: none;">Signature：</td>
                                </tr>
                                <tr style="border: none;">
                                    <td width="70%" style="border: none;"></td>
                                    <td width="30%" style="font-weight: bold; text-align: left; font-size: 14px; border: none;">Date：</td>
                                </tr>
                            </table>
                        </div>
                    </div>
                </div>
            </body>
            </html>
ORDER;
        require_once (\Yii::$app->vendorPath . '/tecnickcom/tcpdf/tcpdf.php');

        $pdf = new \TCPDF(PDF_PAGE_ORIENTATION, PDF_UNIT, PDF_PAGE_FORMAT, true, 'UTF-8', false);
        // 设置打印模式
        $pdf->SetCreator(PDF_CREATOR);
        $pdf->SetAuthor('DaZe');
        $pdf->SetTitle($orderSn);
        $pdf->SetSubject('TCPDF Tutorial');
        $pdf->SetKeywords('TCPDF, PDF, example, test, guide');
        // 是否显示页眉
        $pdf->setPrintHeader(false);
        // 设置页眉字体
        $pdf->setHeaderFont(Array('dejavusans', '', '12'));
        // 页眉距离顶部的距离
        $pdf->SetHeaderMargin('5');
        // 是否显示页脚
        $pdf->setPrintFooter(false);
        // 设置默认等宽字体
        $pdf->SetDefaultMonospacedFont(PDF_FONT_MONOSPACED);
        // 设置行高
        $pdf->setCellHeightRatio(1);
        // 设置左、上、右的间距
        $pdf->SetMargins('10', '10', '10');
        // 设置是否自动分页  距离底部多少距离时分页
        $pdf->SetAutoPageBreak(TRUE, '15');
        // 设置图像比例因子
        $pdf->setImageScale(PDF_IMAGE_SCALE_RATIO);
        if (@file_exists(\Yii::$app->vendorPath . 'tecnickcom/tcpdf/examples/lang/eng.php')) {
            require_once(\Yii::$app->vendorPath . '/tecnickcom/tcpdf/examples/lang/eng.php');
            $pdf->setLanguageArray($l);
        }
        $pdf->setFontSubsetting(true);
        $pdf->AddPage();
        // 设置字体
        $pdf->SetFont('stsongstdlight', '', 10, '', true);
        $pdf->writeHTML($context);

        ob_clean();

        $file_name = $orderSn . '.pdf';
        $path = 'pdfs/' . $file_name;
        $pdf->Output(Yii::$app->basePath . '/web/' . $path, 'F');
        @exec('chmod -R 777 /' . Yii::$app->basePath . '/web' . $path);

        return static::notice(['fileUrl' => $path, 'targetName' => $file_name]);
    }

    /**
     * 下载申请退货单
     */
    public function actionOrderBackingOut()
    {
        $file_name = 'orderBackingOut.xlsx';
        return static::notice(['fileUrl' => $file_name]);
    }
}